/*

Candor Gallery v1.21
http://www.candorgallery.com/
cale@midnightcheese.com

*/

var glassDoneButton;
var whiteInfoButton;

function setup()
{
	glassDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	whiteInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);

	widget.setPreferenceForKey("shipley-002.jpg","prevImage");
	widget.setPreferenceForKey("Darren Shipley","prevArtist");
	widget.setPreferenceForKey("Sentinel","prevTitle");
	widget.setPreferenceForKey("","prevURL");
}

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	$("currentButton").style.display = "none";
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
}

// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	$("currentButton").style.display = "block";
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

var feed = {url:"http://www.candorgallery.com/xml/candor.php"};
	
var xml_request = null;
var thisVersion = 1.2;

function $(element){return document.getElementById(element)}

function show()
{
	if (xml_request != null)
	{
		xml_request.abort();
		xml_request = null;
	}
	xml_request = new XMLHttpRequest();

	xml_request.onload = function(e) {xml_loaded(e, xml_request);}
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", feed.url);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.send(null);
}

function hide() 
{
	document.getElementById("prevButton").src = "Images/previousOff.png";
	document.getElementById("currentButton").src = "Images/currentOn.png";
	
	widget.setPreferenceForKey(image_node,"prevImage");
	widget.setPreferenceForKey(artist_node,"prevArtist");
	widget.setPreferenceForKey(title_node,"prevTitle");
	widget.setPreferenceForKey(website_node,"prevURL");
	
	document.getElementById("title").innerHTML = "<span class='light'>[TITLE]</span>&nbsp;" + title_node.substring(0,25);
	document.getElementById("artist").innerHTML = "<a " + website_node + ">" + artist_node + "</a>&nbsp;<span class='light'>[ARTIST]</span>";
	document.getElementById("image").innerHTML = "<a " + website_node + "><img src='http://www.candorgallery.com/art/" + image_node + "' border='0' width='288' height='151' /></a>";
}

if (window.widget)
{
	widget.onshow = show;
	widget.onhide = hide;
}

function xml_loaded (e, request) 
{
	xml_request = null;
	var xmldoc = request.responseXML;
	title_node = xmldoc.getElementsByTagName("title")[0].firstChild.nodeValue;
	artist_node = xmldoc.getElementsByTagName("artist")[0].firstChild.nodeValue;
	website_node = xmldoc.getElementsByTagName("website")[0].firstChild.nodeValue;	
	image_node = xmldoc.getElementsByTagName("image")[0].firstChild.nodeValue;
	var currentVersion = xmldoc.getElementsByTagName("version")[0].firstChild.nodeValue;
	document.getElementById("title").innerHTML = "<span class='light'>[TITLE]</span>&nbsp;" + title_node.substring(0,25);
	document.getElementById("artist").innerHTML = "<a " + website_node + ">" + artist_node + "</a>&nbsp;<span class='light'>[ARTIST]</span>";
	document.getElementById("image").innerHTML = "<a " + website_node + "><img src='http://www.candorgallery.com/art/" + image_node + "' border='0' width='288' height='151' /></a>";
	
	if (currentVersion > thisVersion)
	{
		$("upgrade").style.display = "block";
	}
		
	if (currentVersion == thisVersion)
	{
		$("upgrade").style.display = "none";
	}
}

function previous()
{
	var prevImage = widget.preferenceForKey("prevImage");
	var prevArtist = widget.preferenceForKey("prevArtist");
	var prevTitle = widget.preferenceForKey("prevTitle");
	var prevURL = widget.preferenceForKey("prevURL");

	document.getElementById("title").innerHTML = "<span class='light'>[TITLE]</span>&nbsp;" + prevTitle.substring(0,25);
	document.getElementById("artist").innerHTML = "<a " + prevURL + ">" + prevArtist + "</a>&nbsp;<span class='light'>[ARTIST]</span>";
	document.getElementById("image").innerHTML = "<a " + prevURL + "><img src='http://www.candorgallery.com/art/" + prevImage + "' border='0' width='288' height='151' /></a>";
	
	document.getElementById("prevButton").src = "Images/previousOn.png";
	document.getElementById("currentButton").src = "Images/currentOff.png";
}

function current()
{
	document.getElementById("title").innerHTML = "<span class='light'>[TITLE]</span>&nbsp;" + title_node.substring(0,25);
	document.getElementById("artist").innerHTML = "<a " + website_node + ">" + artist_node + "</a>&nbsp;<span class='light'>[ARTIST]</span>";
	document.getElementById("image").innerHTML = "<a " + website_node + "><img src='http://www.candorgallery.com/art/" + image_node + "' border='0' width='288' height='151' /></a>";
	
	document.getElementById("prevButton").src = "Images/previousOff.png";
	document.getElementById("currentButton").src = "Images/currentOn.png";
}
